require "defines"

area = {}
function area.create(position,dx,dy)
	if not dy then dy = dx end
	return {{position.x - dx, position.y - dy},{position.x + dx, position.y + dy}}
end

function copy_car(index,car)
	global.cars[index] = {	name = car.name,
							active = car.active,
							destructible = car.destructible,
							minable = car.minable,
							rotatable = car.rotatable,
							operable = car.operable,
							health = car.health,
							orientation = car.orientation,
							effectivity_modifier = car.effectivity_modifier,
							consumption_modifier = car.consumption_modifier,
							friction_modifier = car.friction_modifier,
							energy = car.energy,
							force = car.force,
							inventory = {}}
	for i = 1,3 do
		global.cars[index].inventory[i] = car.get_inventory(i).get_contents()
	end
end

function paste_car(index,car)
	for key,value in pairs(global.cars[index]) do
		if key ~= "name" and key ~= "inventory"  and key ~= "kitt" then car[key] = value end
	end
	for i = 1,3 do
		for name,count in pairs(global.cars[index].inventory[i]) do
			car.get_inventory(i).insert({name = name, count = count})
		end
	end
end

function init()
	global.cars = global.cars or {}
	global.surface = global.surface or {}
	global.position = global.position or {}	
	-- local MapGenSettings = game.surfaces.nauvis.map_gen_settings
	-- MapGenSettings.peaceful_mode = true
	-- MapGenSettings.autoplace_controls["enemy-base"].size = "none"	
	-- global.car_park = game.create_surface("car-park", MapGenSettings)
	log("[DWMC] Initialised")
end

function init_player(player)
	global.cars[player.index] = global.cars[player.index] or {}
	
	-- player.insert("car-key")
	-- player.insert("car")
	-- player.insert("solid-fuel")
	log("[DWMC] Initialised player ["..player.index.."]"..player.name)
end

script.on_init(function(event)
	init()
end)

script.on_event(defines.events.on_player_created, function(event)
	local player = game.get_player(event.player_index)
	init_player(player)
end)

script.on_configuration_changed(function(event)
	init()
	for _,player in pairs(game.players) do
		init_player(player)
	end
end)

script.on_event(defines.events.on_built_entity, function(event)

	local index = event.player_index
	local player = game.get_player(index)
	local entity = event.created_entity
	if entity.name == "car-key" then
	
		if not player.cursor_stack.valid_for_read then 
			player.cursor_stack.set_stack{name = "car-key", count = 1}
		elseif player.cursor_stack.name == "car-key" then
			player.cursor_stack.count = player.cursor_stack.count + 1
		elseif player.insert({name = "car-key", count = 1}) == 0 then
			player.surface.spill_item_stack(player.position,{name = "car-key", count = 1})
		end
		
		local car = entity.surface.find_entities_filtered{area = area.create(entity.position,1), type = "car"}[1]
		
		if car then
		
			local carOwned = false
			
			for player_index,car2 in pairs(global.cars) do
				if car == car2 and player_index ~= index then
					player.print("This car is owned by "..game.players[player_index].name)
					game.players[player_index].print(player.name.." has tried to take your car!")
					carOwned = true
				end
			end
			
			if not carOwned and global.cars[index] == car then
				car.operable = not car.operable
				car.active = car.operable
				car.minable = car.operable
				local locked = "locked"
				if car.operable then locked = "unlocked" end
				player.print("Your car is now "..locked)
			else
				global.cars[index] = car
				player.print("This is now your car")
			end			
			
		elseif global.cars[index].valid then
			local car = global.cars[index]
			
			copy_car(index,car)
			
			local kitt = entity.surface.create_entity{name = car.name.."DWMC", position = car.position, force = player.force, direction = car.direction}
			kitt.health = car.health
			global.cars[index].kitt = kitt
			kitt.set_command({type = defines.command.go_to_location, destination = entity.position, distraction = defines.distraction.none})
			
			car.destroy()
			global.surface[index] = entity.surface
			global.position[index] = entity.position
			global.surface[index].create_entity{name = "Dude_sound", position = global.position[index]}
			player.print("Your car is on its way")
			
		elseif global.cars[index].kitt then
			global.surface[index] = entity.surface
			global.position[index] = entity.position
			global.cars[index].kitt.set_command({type = defines.command.go_to_location, destination = entity.position, distraction = defines.distraction.none})
			player.print("Your car is on its way")
			
		else
			player.print("You don't own a car, you can claim a car by clicking these keys on a car (or tank)")
		end
		
		entity.destroy()
		
	end
end)

script.on_event(defines.events.on_tick, function(event)
	if event.tick % 40 == 0 then 
		for index,player in pairs(game.players) do
			if global.surface[index] and global.position[index] then
			
				local kitt = global.surface[index].find_entities_filtered{name = global.cars[index].name.."DWMC", area = area.create(global.position[index], 7.5)}
				if kitt[1] == global.cars[index].kitt then 
					
					local car = global.surface[index].create_entity{name = global.cars[index].name, position = kitt[1].position}
					paste_car(index,car)
					--car.teleport(kitt[1].position,kitt[1].surface)
					car.orientation = kitt[1].orientation
					global.cars[index] = car
					kitt[1].destroy()
					player.print("Your car has arrived")
					global.surface[index] = nil
					global.position[index] = nil
					
				else
					global.surface[index].create_entity{name = "homing-beacon", position = global.position[index]}
					global.cars[index].kitt.force.chart(global.cars[index].kitt.surface, area.create(global.cars[index].kitt.position,32))
				end
			end
		end
	end
end)

script.on_event(defines.events.on_preplayer_mined_item, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				if index == event.player_index then
					game.players[index].print("You no longer own a car, use your keys to claim a new one")
				else
					game.players[index].print(game.players[event.player_index].name.." mined your car, use your keys to claim a new one")
				end
			end
		end
	elseif event.entity.type == "unit" then
		for index,car in pairs(global.cars) do
			if not car.valid and event.entity == car.kitt then
				global.cars[index] = {}
				global.surface[index] = nil
				global.position[index] = nil
				if index == event.player_index then
					game.players[index].print("You no longer own a car, use your keys to claim a new one")
				else
					game.players[index].print(game.players[event.player_index].name.." mined your car, use your keys to claim a new one")
				end
			end
		end
	end
end)

script.on_event(defines.events.on_robot_pre_mined, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				game.players[index].print("Robots mined your car, use your keys to claim a new one")
			end
		end
	elseif event.entity.type == "unit" then
		for index,car in pairs(global.cars) do
			if not car.valid and event.entity == car.kitt then
				global.cars[index] = {}
				global.surface[index] = nil
				global.position[index] = nil
				game.players[index].print("Robots mined your car, use your keys to claim a new one")
			end
		end
	end
end)

script.on_event(defines.events.on_entity_died, function(event)
	if event.entity.type == "car" then
		for index,car in pairs(global.cars) do
			if event.entity == car then
				global.cars[index] = {}
				game.players[index].print("Your car is destroyed, use your keys to claim a new one")
			end
		end
	elseif event.entity.type == "unit" then
		for index,car in pairs(global.cars) do
			if not car.valid and event.entity == car.kitt then
				global.cars[index] = {}
				global.surface[index] = nil
				global.position[index] = nil
				game.players[index].print("Your car is destroyed, use your keys to claim a new one")
			end
		end
	end
end)